Subject: Re: bug#66988: 30.0.50; treesit-forward-sexp not working properly in js-ts-mode and tsx-ts-mode

From: Yuan Fu <[email-masked]>
Date: Sat, 18 Nov 2023 10:57:56 -0800

> On Nov 15, 2023, at 4:19 AM, Eli Zaretskii <[email-masked]> wrote:
> 
>> From: Yuan Fu <[email-masked]>
>> Date: Tue, 14 Nov 2023 22:28:34 -0800
>> Cc: Dmitry Gutov <[email-masked]>,
>> Theodor Thornhill <[email-masked]>,
>> [email-masked],
>> [email-masked]
>> 
>>> Is it feasible to have a variable that controls whether the full
>>> matches are implied in these APIs?  Then we could start by making it
>>> optional, and at some later time make it the default.
>> 
>> It’s feasible, but I don’t think it’s TRT. The major mode author should have the control over whether the full match is implied, not the user. It doesn’t make sense to toggle the variable either. If you change that variable, major mode code must also change to be correct.
> 
> So what do you suggest that we do about this issue?

We change every treesit function that takes a regexp for matching node type names to imply full match. I think most people wrote code as if these functions use full match, so the breakage should be small. And I can forecast this change in as many channels as I can.

Yuan